<?php
#-----------------------------------------------------#
#          ********* ROTORCMS *********               #
#              Made by  :  VANTUZ                     #
#               E-mail  :  visavi.net@mail.ru         #
#                 Site  :  http://pizdec.ru           #
#             WAP-Site  :  http://visavi.net          #
#                  ICQ  :  36-44-66                   #
#  Вы не имеете право вносить изменения в код скрипта #
#        для его дальнейшего распространения          #
#-----------------------------------------------------#	
require_once ('../includes/start.php');
require_once ('../includes/functions.php');
require_once ('../includes/header.php');
include_once ('../themes/' . $config['themes'] . '/index.php');

if (isset($_GET['act'])) {
  $act = check($_GET['act']);
} else {
  $act = 'index';
} 
if (isset($_GET['start'])) {
  $start = abs(intval($_GET['start']));
} else {
  $start = 0;
} 

if (is_admin(array(101, 102, 103, 105))) {
  show_title('site.png', 'Админ-чат');
  $config['newtitle'] = 'Админ-чат';

  switch ($act):
  # ###########################################################################################
  # #                                    Главная страница                                    ##
  # ###########################################################################################
  case "index":

    echo '<a href="#down"><img src="../images/img/downs.gif" alt="image" /></a> ';
    echo '<a href="chat.php?rand=' . mt_rand(100, 999) . '&amp;' . SID . '">Обновить</a> / ';
    echo '<a href="../pages/smiles.php?' . SID . '">Смайлы</a> / ';
    echo '<a href="../pages/tegi.php?' . SID . '">Теги</a><hr />';

    $total = DB :: $dbh -> querySingle("SELECT count(*) FROM `chat`;");

    setcookie("chatcount", stats_chat(), time() + 3600 * 24 * 30, '/', '');

    if ($total > 0) {
      if ($start >= $total) {
        $start = 0;
      } 

      $querychat = DB :: $dbh -> query("SELECT * FROM `chat` ORDER BY `chat_time` DESC LIMIT " . $start . ", " . $config['chatpost'] . ";");

      while ($data = $querychat -> fetch()) {
        echo '<div class="b">';

        echo '<div class="img">' . user_avatars($data['chat_user']) . '</div>';

        echo '<b><a href="../pages/anketa.php?uz=' . $data['chat_user'] . '&amp;' . SID . '">' . nickname($data['chat_user']) . '</a></b> <small>(' . date_fixed($data['chat_time']) . ')</small><br />';
        echo user_title($data['chat_user']) . ' ' . user_online($data['chat_user']) . '</div>';

        if ($log != $data['chat_user']) {
          echo '<div class="right">';
          echo '<a href="chat.php?act=reply&amp;id=' . $data['chat_id'] . '&amp;start=' . $start . '&amp;' . SID . '">Отв</a> / ';
          echo '<a href="chat.php?act=quote&amp;id=' . $data['chat_id'] . '&amp;start=' . $start . '&amp;' . SID . '">Цит</a></div>';
        } 

        if ($log == $data['chat_user'] && $data['chat_time'] + 600 > SITETIME) {
          echo '<div class="right"><a href="chat.php?act=edit&amp;id=' . $data['chat_id'] . '&amp;start=' . $start . '&amp;' . SID . '">Редактировать</a></div>';
        } 

        echo '<div>' . bb_code($data['chat_text']) . '<br />';

        if (!empty($data['chat_edit'])) {
          echo '<img src="../images/img/exclamation_small.gif" alt="image" /> <small>Отредактировано: ' . nickname($data['chat_edit']) . ' (' . date_fixed($data['chat_edit_time']) . ')</small><br />';
        } 

        echo '<span class="data">(' . $data['chat_brow'] . ', ' . $data['chat_ip'] . ')</span>';

        echo '</div>';
      } 

      page_jumpnavigation('chat.php?', $config['chatpost'], $start, $total);
      page_strnavigation('chat.php?', $config['chatpost'], $start, $total);
    } else {
      show_error('Сообщений нет, будь первым!');
    } 

    echo '<div class="form" id="form">';
    echo '<form action="chat.php?act=add&amp;uid=' . $_SESSION['token'] . '&amp;' . SID . '" name="form" method="post"><b>Сообщение:</b><br />';
    echo '<textarea cols="25" rows="3" name="msg"></textarea><br />';

    if (!empty($udata['users_bbpanel'])) {
      quickpaste('msg');
      quickcode();
      quicksmiles();
    } 

    echo '<input type="submit" value="Написать" /></form></div><br />';

    if (is_admin(array(101)) && $total > 0) {
      echo '<img src="../images/img/error.gif" alt="image" /> <a href="chat.php?act=prodel&amp;' . SID . '">Очистить чат</a><br />';
    } 
    break;
  # ###########################################################################################
  # #                                   Добавление сообщений                                 ##
  # ###########################################################################################
  case "add":

    $msg = check($_POST['msg']);
    $uid = check($_GET['uid']);

    if ($uid == $_SESSION['token']) {
      if (utf_strlen($msg) >= 5 && utf_strlen($msg) < 1500) {
        $msg = no_br($msg);
        $msg = smiles($msg);

        DB :: $dbh -> query("INSERT INTO `chat` (`chat_user`, `chat_text`, `chat_ip`, `chat_brow`, `chat_time`) VALUES (?, ?, ?, ?, ?);", array($log, $msg, $ip, $brow, SITETIME));
        DB :: $dbh -> query("DELETE FROM `chat` WHERE `chat_time` < (SELECT MIN(`chat_time`) FROM (SELECT `chat_time` FROM `chat` ORDER BY `chat_time` DESC LIMIT " . $config['maxpostchat'] . ") AS del);");

        setcookie("chatcount", stats_chat(), time() + 3600 * 24 * 30, '/', '');

        $_SESSION['note'] = 'Сообщение успешно добавлено!';
        header ("Location: chat.php?" . SID);
        exit;
      } else {
        show_error('Ошибка! Слишком длинное или короткое сообщение!');
      } 
    } else {
      show_error('Ошибка! Неверный идентификатор сессии, повторите действие!');
    } 

    echo '<img src="../images/img/back.gif" alt="image" /> <a href="chat.php?' . SID . '">Вернуться</a><br />';
    break;
  # ###########################################################################################
  # #                                   Ответ на сообщение                                   ##
  # ###########################################################################################
  case "reply":

    $id = abs(intval($_GET['id']));

    echo '<b><big>Ответ на сообщение</big></b><br /><br />';

    $querychat = DB :: $dbh -> query("SELECT * FROM `chat` WHERE `chat_id`=? LIMIT 1;", array($id));
    $post = $querychat -> fetch();

    if (!empty($post)) {
      echo '<div class="b"><img src="../images/img/edit.gif" alt="image" /> <b><a href="../pages/anketa.php?uz=' . $post['chat_user'] . '&amp;' . SID . '">' . nickname($post['chat_user']) . '</a></b> ' . user_title($post['chat_user']) . ' ' . user_online($post['chat_user']) . ' <small>(' . date_fixed($post['chat_time']) . ')</small></div>';
      echo '<div>Сообщение: ' . bb_code($post['chat_text']) . '</div><hr />';

      echo '<div class="form" id="form">';
      echo '<form action="chat.php?act=add&amp;uid=' . $_SESSION['token'] . '&amp;' . SID . '" method="post">';
      echo 'Сообщение:<br />';
      echo '<textarea cols="25" rows="5" name="msg" id="msg">[b]' . nickname($post['chat_user']) . '[/b], </textarea><br />';
      echo '<input type="submit" value="Ответить" /></form></div><br />';
    } else {
      show_error('Ошибка! Выбранное вами сообщение для ответа не существует!');
    } 

    echo '<img src="../images/img/back.gif" alt="image" /> <a href="chat.php?start=' . $start . '&amp;' . SID . '">Вернуться</a><br />';
    break;
  # ###########################################################################################
  # #                                   Цитирование сообщения                                ##
  # ###########################################################################################
  case "quote":

    $id = abs(intval($_GET['id']));

    echo '<b><big>Цитирование</big></b><br /><br />';

    $querychat = DB :: $dbh -> query("SELECT * FROM `chat` WHERE `chat_id`=? LIMIT 1;", array($id));
    $post = $querychat -> fetch();

    if (!empty($post)) {
      $post['chat_text'] = nosmiles($post['chat_text']);
      $post['chat_text'] = preg_replace('|\[q\](.*?)\[/q\](<br />)?|', '', $post['chat_text']);
      $post['chat_text'] = str_replace('<br />', "\r\n", $post['chat_text']);

      echo '<div class="form" id="form">';
      echo '<form action="chat.php?act=add&amp;start=' . $start . '&amp;uid=' . $_SESSION['token'] . '&amp;' . SID . '" method="post">';
      echo 'Сообщение:<br />';
      echo '<textarea cols="25" rows="5" name="msg" id="msg">[q][b]' . nickname($post['chat_user']) . '[/b] (' . date_fixed($post['chat_time']) . ')' . "\r\n" . $post['chat_text'] . '[/q]' . "\r\n" . '</textarea><br />';
      echo '<input type="submit" value="Ответить" /></form></div><br />';
    } else {
      show_error('Ошибка! Выбранное вами сообщение для цитирования не существует!');
    } 

    echo '<img src="../images/img/back.gif" alt="image" /> <a href="chat.php?start=' . $start . '&amp;' . SID . '">Вернуться</a><br />';
    break;
  # ###########################################################################################
  # #                                   Подготовка к редактированию                          ##
  # ###########################################################################################
  case "edit":

    $id = abs(intval($_GET['id']));

    $querypost = DB :: $dbh -> query("SELECT * FROM chat WHERE chat_id=? AND chat_user=? LIMIT 1;", array($id, $log));
    $post = $querypost -> fetch();

    if (!empty($post)) {
      if ($post['chat_time'] + 600 > SITETIME) {
        $post['chat_text'] = nosmiles($post['chat_text']);
        $post['chat_text'] = str_replace('<br />', "\r\n", $post['chat_text']);

        echo '<img src="../images/img/edit.gif" alt="image" /> <b>' . nickname($post['chat_user']) . '</b> <small>(' . date_fixed($post['chat_time']) . ')</small><br /><br />';

        echo '<div class="form" id="form">';
        echo '<form action="chat.php?act=editpost&amp;id=' . $id . '&amp;start=' . $start . '&amp;uid=' . $_SESSION['token'] . '&amp;' . SID . '" method="post">';
        echo 'Редактирование сообщения:<br />';
        echo '<textarea cols="25" rows="5" name="msg">' . $post['chat_text'] . '</textarea><br />';
        echo '<input value="Редактировать" name="do" type="submit" /></form></div><br />';
      } else {
        show_error('Ошибка! Редактирование невозможно, прошло более 10 минут!!');
      } 
    } else {
      show_error('Ошибка! Сообщение удалено или вы не автор этого сообщения!');
    } 

    echo '<img src="../images/img/back.gif" alt="image" /> <a href="chat.php?start=' . $start . '&amp;' . SID . '">Вернуться</a><br />';
    break;
  # ###########################################################################################
  # #                                    Редактирование сообщения                            ##
  # ###########################################################################################
  case "editpost":

    $uid = check($_GET['uid']);
    $id = abs(intval($_GET['id']));
    $msg = check($_POST['msg']);

    if ($uid == $_SESSION['token']) {
      if (utf_strlen($msg) >= 5 && utf_strlen($msg) < 1500) {
        $querypost = DB :: $dbh -> query("SELECT * FROM chat WHERE chat_id=? AND chat_user=? LIMIT 1;", array($id, $log));
        $post = $querypost -> fetch();

        if (!empty($post)) {
          if ($post['chat_time'] + 600 > SITETIME) {
            $msg = no_br($msg);
            $msg = smiles($msg);

            DB :: $dbh -> query("UPDATE chat SET chat_text=?, chat_edit=?, chat_edit_time=? WHERE chat_id=?", array($msg, $log, SITETIME, $id));

            $_SESSION['note'] = 'Сообщение успешно отредактировано!';
            header ("Location: chat.php?start=$start&" . SID);
            exit;
          } else {
            show_error('Ошибка! Редактирование невозможно, прошло более 10 минут!!');
          } 
        } else {
          show_error('Ошибка! Сообщение удалено или вы не автор этого сообщения!');
        } 
      } else {
        show_error('Ошибка! Слишком длинное или короткое сообщение!');
      } 
    } else {
      show_error('Ошибка! Неверный идентификатор сессии, повторите действие!');
    } 

    echo '<img src="../images/img/back.gif" alt="image" /> <a href="chat.php?act=edit&amp;id=' . $id . '&amp;start=' . $start . '&amp;' . SID . '">Вернуться</a><br />';
    echo '<img src="../images/img/reload.gif" alt="image" /> <a href="chat.php?start=' . $start . '&amp;' . SID . '">В админ-чат</a><br />';
    break;
  # ###########################################################################################
  # #                                 Подтверждение очистки                                  ##
  # ###########################################################################################
  case "prodel":
    echo 'Вы уверены что хотите удалить все сообщения в админ-чате?<br />';
    echo '<img src="../images/img/error.gif" alt="image" /> <b><a href="chat.php?act=alldel&amp;uid=' . $_SESSION['token'] . '&amp;' . SID . '">Да, уверен!</a></b><br /><br />';

    echo '<img src="../images/img/back.gif" alt="image" /> <a href="chat.php?' . SID . '">Вернуться</a><br />';
    break;
  # ###########################################################################################
  # #                                   Очистка админ-чата                                   ##
  # ###########################################################################################
  case "alldel":

    $uid = check($_GET['uid']);

    if (is_admin(array(101))) {
      if ($uid == $_SESSION['token']) {
        DB :: $dbh -> query("TRUNCATE `chat`;");

        $_SESSION['note'] = 'Админ-чат успешно очищен!';
        header ("Location: chat.php?" . SID);
        exit;
      } else {
        show_error('Ошибка! Неверный идентификатор сессии, повторите действие!');
      } 
    } else {
      show_error('Ошибка! Очищать админ-чат могут только суперадмины!');
    } 

    echo '<img src="../images/img/back.gif" alt="image" /> <a href="chat.php?' . SID . '">Вернуться</a><br />';
    break;

  default:
    header("location: chat.php?" . SID);
    endswitch;

    echo '<img src="../images/img/panel.gif" alt="image" /> <a href="index.php?' . SID . '">В админку</a><br />';
    echo '<img src="../images/img/homepage.gif" alt="image" /> <a href="../index.php?' . SID . '">На главную</a><br />';
  } else {
  header ('Location: ' . BASEDIR . 'index.php?' . SID);
  exit;
} 

include_once ('../themes/' . $config['themes'] . '/foot.php');

?>